## Telescope Fall 2020

#### Links
- [GitHub Repo](https://github.com/rcos/Telescope)
- [Mattermost channel](https://chat.rcos.io/rcos/channels/telescope)

#### Team
- Antonia "Nia" Calia-Bogan (PM, Full-Stack)
    - Mattermost: @alfriadox
    - Discord: @[👁]#2020
    - RPI email: caliaa2@rpi.edu
    - Other email: acaliabogan@acaliabogan.dev

#### Description
Telescope is a website that manages projects, developers, and attendance for 
RCOS. We aim to replace the current system, 
[Observatory](https://github.com/rcos/observatory-server).
Key features include improved attendance tracking, user and project management,
and a comprehensive set of tools for mentors and coordinators. 

#### Technology:
Telescope's backend is written in [rust](https://www.rust-lang.org/) and uses 
the [actix-web](https://actix.rs/) web framework to route and serve requests.
Telescope encrypts all traffic using SSL/TLS technology via 
[openssl](https://www.openssl.org/). The backend interfaces with a 
[Postgres](https://www.postgresql.org/) database using the 
[diesel](http://diesel.rs/) ORM and query building framework.

Telescope's frontend is built using the [handlebars](https://handlebarsjs.com/) 
templating engine and [bootstrap](https://getbootstrap.com/) framework. 

#### Milestones:
I intend to release Telescope during this semester. 
The predicted development schedule is as follows:
- Week 1 (September 20 - 26):
    - User Profile Pages
    - Editing User Profiles
    - Developers index page
- Week 2 (September 27 - October 3):
    - Email Confirmations
    - Registration/signup system
    - Password Recovery system.
- Week 3 (October 4 - 10):
    - Group / Group Membership Modeling
    - Group / Group Membership API Endpoints
- Week 4 (October 11 - 17):
    - Attendance Modeling
    - Attendance API endpoints
- Week 5 (October 18 - 24):
    - Attendance Management pages
    - Attendance Recording pages
- Week 6 (October 25 - 31):
    -  Projects Modeling
    -  API Endpoints for projects.
- Week 7 (November 1 - 7):
    - Project pages
    - Editing projects
    - Projects index page
- Week 8 (November 8 - 14):
    - Group Management Pages
    - Mentor / Coordinator / Professor Group Seeding (?)
        - The Role / Permission system is still slightly under-defined. This
            should become more defined during the semester depending on time 
            constraints and the needs of RCOS.    
- Week 9 (November 15 - 21):
    - Beta / Testing Release.
- Week 10 (November 22 - 28):
    - Migrations from old database.
    - Public 1.0 release. 
- Week 11 (November 29 - December 5):
    - Final Presentation
